// The contents of this file are subject to the Mozilla Public License
// Version 1.1 (the "License"); you may not use this file except in
// compliance with the License.  You may obtain a copy of the License
// at http://www.mozilla.org/MPL/
//
// Software distributed under the License is distributed on an "AS IS"
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
// See the License for the specific language governing rights and
// limitations under the License.
//
// The Original Code is
// "Michael C. Lee, Jr's small example of the many features of Java3D".
//
// The Initial Developer of the Original Code is GameSpawn, Inc.
// Portions created by GameSpawn, Inc. are
// Copyright (C) 2000 GameSpawn, Inc.  All Rights Reserved.
//
// Contributor(s):
package com.gamespawn.lab.mikelee.j3d.examples;

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import java.io.*;
import javax.vecmath.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.behaviors.picking.*;

/**
* Demonstrates some of the basic features of Java3D.
*
* @author Michael C. Lee, Jr.
* @version Java 1.2, Java3d 1.1
*/
public class MoveViewer extends Applet
{
    public MoveViewer()
    {
    	  setLayout(new BorderLayout());
        Canvas3D c = new Canvas3D(null);
System.out.println("1");
//        System.out.println(c.getStereoEnable());
//        c.setStereoEnable(true);
    	  add("Center", c);

	      // Create a simple scene and attach it to the virtual universe
    	  BranchGroup scene = createSceneGraph(c);
  	    SimpleUniverse u = new SimpleUniverse(c);

        // This will move the ViewPlatform back a bit so the
        // objects in the scene can be viewed.
        u.getViewingPlatform().setNominalViewingTransform();

      	u.addBranchGraph(scene);

        Primitive shape2 = new Sphere(.3f, Primitive.GENERATE_TEXTURE_COORDS, createAppearance("images/webster.jpg"));
        shape2.setPrimitiveFlags(Primitive.GENERATE_NORMALS);

		System.out.println("4");
        BranchGroup brgr = new BranchGroup();
		System.out.println("5");

        brgr.addChild(createObject(shape2, 0.6, -0.6, -0.6));
		System.out.println("6");
       	u.addBranchGraph(brgr);
		System.out.println("7");
    }

    /**
    * Creates a BranchGroup with all the geometries and appearances for our scene.
    *
    * @param canvas The component which the 3d scene will be rendered onto.
    * @return A branch group containing the geometries, appearances and behaviors
    * for our scene.
    */
    public BranchGroup createSceneGraph(Canvas3D canvas)
    {
System.out.println("2");
        BranchGroup objRoot = new BranchGroup();

    	// Create a bounds for the background and lights
      BoundingSphere bounds =
	    new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);

    	// Set up the background
/*            TextureLoader bgTexture = new TextureLoader("images/bg.jpg", this);
    	Background bg = new Background(bgTexture.getImage());
	    bg.setApplicationBounds(bounds);
        objRoot.addChild(bg);*/

    	// Set up the global lights
    	Color3f lColor1 = new Color3f(0.7f, 0.7f, 0.7f);
	    Vector3f lDir1  = new Vector3f(-1.0f, -1.0f, -1.0f);
    	Color3f alColor = new Color3f(0.2f, 0.2f, 0.2f);

	    AmbientLight aLgt = new AmbientLight(alColor);
    	aLgt.setInfluencingBounds(bounds);
	    DirectionalLight lgt1 = new DirectionalLight(lColor1, lDir1);
    	lgt1.setInfluencingBounds(bounds);
	    objRoot.addChild(aLgt);
    	objRoot.addChild(lgt1);

        Primitive shape = new Box(.3f,.3f,.3f, Primitive.GENERATE_TEXTURE_COORDS, createAppearance("images/webster.jpg"));
        shape.setPrimitiveFlags(Primitive.GENERATE_NORMALS);

        Primitive shape2 = new Sphere(.3f, Primitive.GENERATE_TEXTURE_COORDS, createAppearance("images/webster.jpg"));
        shape2.setPrimitiveFlags(Primitive.GENERATE_NORMALS);

        objRoot.addChild(createObject(shape, 0.6, 0.6, -0.6));
        objRoot.addChild(createObject(shape2, 0.0, 0.0, 0.0));
        objRoot.addChild(loadObjectFromFile("p51_mustang.obj", -0.4, -0.4, 0.0));

        PickRotateBehavior behavior = new PickRotateBehavior(objRoot, canvas, bounds,
							 PickObject.USE_BOUNDS);
        objRoot.addChild(behavior);

        PickZoomBehavior behavior2 = new PickZoomBehavior(objRoot, canvas, bounds,
						      PickObject.USE_BOUNDS);
        objRoot.addChild(behavior2);
        PickTranslateBehavior behavior3 = new PickTranslateBehavior(objRoot, canvas, bounds,
								PickObject.USE_BOUNDS);
        objRoot.addChild(behavior3);

        objRoot.compile();
System.out.println("3");
        return objRoot;
    }

    public Appearance createAppearance(String fileName)
    {
      	Appearance app = new Appearance();
      	// Globally used colors
	      Color3f black = new Color3f(0.0f, 0.0f, 0.0f);
    	  Color3f white = new Color3f(1.0f, 1.0f, 1.0f);

  		TextureLoader tex = new TextureLoader(fileName, this);
	  	app.setTexture(tex.getTexture());

  		// Set up the material properties
      //		app.setMaterial(new Material(white, black, white, black, 1.0f));
   		return app;
    }

    public TransformGroup loadObjectFromFile(String filename, double xpos, double ypos, double zpos)
    {
  	    Transform3D t = new Transform3D();
      	t.set(0.5, new Vector3d(xpos, ypos, zpos));
      	TransformGroup objTrans = new TransformGroup(t);
	      objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
      	objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        objTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
        double creaseAngle = 60.0;

      	int flags = ObjectFile.RESIZE;
	      ObjectFile f = new ObjectFile(flags,(float)(creaseAngle * Math.PI / 180.0));
      	Scene s = null;
  	    try
        {
        	  s = f.load(filename);
  	    }
      	catch (FileNotFoundException e)
        {
	          System.err.println(e);
      	    System.exit(1);
	      }
      	catch (ParsingErrorException e)
        {
	          System.err.println(e);
    	      System.exit(1);
  	    }
      	catch (IncorrectFormatException e)
        {
	          System.err.println(e);
    	      System.exit(1);
	      }

        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
      	objTrans.addChild(s.getSceneGroup());

      	return objTrans;
    }

    public TransformGroup createObject(Primitive shape, double xpos, double ypos, double zpos)
    {
      	// Create a transform group node to scale and position the object.
	      Transform3D t = new Transform3D();
      	t.set(1.0, new Vector3d(xpos, ypos, zpos));
	      TransformGroup objTrans = new TransformGroup(t);
        objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        objTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);

      	// Create a second transform group node and initialize it to the
	      // identity.  Enable the TRANSFORM_WRITE capability so that
      	// our behavior code can modify it at runtime.
	      TransformGroup spinTg = new TransformGroup();
        spinTg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        spinTg.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        spinTg.setCapability(TransformGroup.ENABLE_PICK_REPORTING);

	    // Create a simple shape leaf node and set the appearance
//    	Shape3D shape = new Tetrahedron();
//	    shape.setAppearance(app);

      	// add it to the scene graph.
  	    spinTg.addChild(shape);

        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);

  	    objTrans.addChild(spinTg);

      	return objTrans;
    }

    public static void main(String[] args)
    {
        new MainFrame(new MoveViewer(), 700, 700);
    }
}
